(document:surround "/std/frame")

(define (write-n-commit)
  (woo-catch/message (thunk
    (woo-write "/lilo/source"
      'source (lilo-conf text)
      'liloopts (lilo-opts text))
    (woo-write "/lilo/commit" 'confonly (config-only state)))))

(define (write-data)
  (woo-catch/message (thunk
    (woo-write "/lilo/source"
      'source (lilo-conf text)
      'liloopts (lilo-opts text)))))

(define (read-data)
  (woo-catch/message (thunk
    (let ((data (woo-read-first "lilo/source")))
      (lilo-conf text (woo-get-option data 'source))
      (lilo-opts text (woo-get-option data 'liloopts)) ))))

(gridbox columns "0;100;0;0;0" align "top"
  (document:id config-only
    (checkbox (_ "Don't install bootloader") state #f))
  (spacer)
  (button (_ "Simple mode")
    (when clicked (write-data) (frame:replace "/lilo")))
  (button (_ "Expert mode")
    (when clicked (write-data) (frame:replace "/lilo/expert")))
  (button (_ "Edit lilo.conf") activity #f)
)

(document:id lilo-conf (textbox))

(gridbox columns "0;100" align 'bottom
  (label (_ "Lilo options:"))
  (document:id lilo-opts (edit)))

(or (global 'frame:next)
    (gridbox columns "50;0;0;50" align "top"
        (spacer)
        (button (_ "Apply") (when clicked (write-n-commit)))
        (button (_ "Reset") (when clicked (read-data)))
        (spacer)))

(and (global 'frame:next)
  (frame:on-next (thunk (or (write-n-commit) 'cancel))))

(document:root (when loaded
  (and (global 'frame:next) (frame:back-activity #f))
  (read-data)))
